# Compatibility with legacy rpm.
%{!?_lib:%define _lib	lib}

%ifnarch ia64 
Conflicts: glibc < 2.1.90 
%endif 

%define db1_versions 1.85
%define db2_versions 2
%define db3_versions 3.3.11
%define db4_versions 4.1.25

%define _libdb_a                libdb-${soversion}.a
%define _libcxx_a               libdb_cxx-${soversion}.a

Summary: The Berkeley DB database library for Red Hat Linux 7.x compatibility.
Name: compat-db
Version: 4.1.25
Release: 9
# Tarball taken from glibc 2.1.3  
#Source0: http://www.sleepycat.com/update/2.7.7/db-2.7.7.tar.gz  
Source0: db2-glibc-2.1.3.tar.gz
Source3: http://www.sleepycat.com/update/3.3.11/db-3.3.11.tar.gz
Source5: http://www.sleepycat.com/update/4.1.25/db-4.1.25.tar.gz
Source6: http://www.sleepycat.com/update/1.85/db.1.85.tar.gz

# Patch to make it standalone
Patch0: db2-glibc-2.1.3.patch
Patch1: db2-2.4.14-db2.patch
Patch2: db2-2.4.14-s390.patch
Patch3: db2-2.4.14-nodebug.patch
Patch4: db2-2.4.14-fileid_64bit_fix.patch
Patch5: db2-build.patch

Patch8: http://www.sleepycat.com/update/3.3.11/patch.3.3.11.1
Patch9: http://www.sleepycat.com/update/3.3.11/patch.3.3.11.2

Patch17: patch.4.1.25.1
Patch18: patch.4.1.25.2

Patch20: db.1.85.patch
Patch21: db.1.85.s390.patch
Patch22: db.1.85.nodebug.patch

Obsoletes: db1, db1-devel
Obsoletes: db2, db2-devel, db2-utils
Obsoletes: db3, db3-devel, db3-utils
Obsoletes: db31, db32, db3x
Obsoletes: db4 < 4.2, db4-devel < 4.2, db4-utils < 4.2
URL: http://www.sleepycat.com/
License: BSDish
Group: System Environment/Libraries
BuildPreReq: findutils, libtool, perl, sed
BuildRoot: %{_tmppath}/%{name}-root

%description
The Berkeley Database (Berkeley DB) is a programmatic toolkit that provides
embedded database support for both traditional and client/server applications.
This package contains various versions of Berkeley DB which were included in
previous releases of Red Hat Linux.

%prep
%setup -q -c -a 3 -a 5 -a 6

pushd db.1.85
%patch20 -p1 -b .patch
%patch21 -p1 -b .fPIC
%patch22 -p1 -b .debug
popd

pushd db2
%patch0 -p1  
%patch1 -p1 -b .db2  
%patch2 -p1 -b .fpic  
%patch3 -p1 -b .nodebug  
%patch4 -p1 -b .64fix  
%patch5 -p1 -b .build
popd

pushd db-3.3.11
%patch8 -p0 -b .1
%patch9 -p0 -b .2
popd

pushd db-4.1.25
%patch17 -p0
%patch18 -p0
popd


mkdir docs
for version in 2 %{db3_versions} ; do
	mkdir docs/db-${version}
	install -m644 db*${version}/{README,LICENSE} docs/db-${version}
done

%build
# Set CFLAGS for use when building db2, where there's no configure script to
# pick it up from a %%configure macro.
CFLAGS="$RPM_OPT_FLAGS"; export CFLAGS

# Cause C++ libraries to be linked with libstdc++.
LIBXSO_LIBS=-lstdc++; export LIBXSO_LIBS

pushd db.1.85
(cd include && ln -sf db.h db_185.h)
cd PORT/linux
make OORG="$RPM_OPT_FLAGS"
sover=`echo libdb.so.* | sed 's/libdb.so.//'`
ln -sf libdb1.so.$sover                 libdb1.so
ln -sf libdb.so.$sover                  libdb1.so.$sover
popd

pushd db2
make
popd

for version in %{db3_versions} ; do
	pushd db-${version}/dist
# XXX --enable-posixmutexes is useful for threads but useless for interprocess locking.
# XXX --enable-diagnostic should be disabled for production (but is useful).
# XXX --enable-debug_{r,w}op should be disabled for production.

	libtoolize --force 
	%configure --prefix=%{_prefix} \
		--enable-compat185 \
		--enable-shared --disable-static \
		--enable-rpc \
		# --enable-diagnostic \
		# --enable-debug --enable-debug_rop --enable-debug_wop \
		# --enable-posixmutexes

	soversion=`echo ${version} | cut -f1,2 -d.`
	make libdb=%{_libdb_a} libcxx=%{_libcxx_a}
	popd
done

for version in %{db4_versions} ; do
	pushd db-${version}/dist

# Link 4.1.25 and 4.2.52 against -lpthread
	unset LIBSO_LIBS
	[ "$version" != "4.0.14" ] && export LIBSO_LIBS=-lpthread

# XXX --enable-posixmutexes is useful for threads but useless for interprocess locking.
# XXX --enable-diagnostic should be disabled for production (but is useful).
# XXX --enable-debug_{r,w}op should be disabled for production.
# XXX --enable-java
	libtoolize --force 
	%configure --prefix=%{_prefix} \
		--enable-compat185 \
		--enable-shared --disable-static \
		--enable-rpc \
		# --enable-diagnostic \
		# --enable-debug --enable-debug_rop --enable-debug_wop \
		# --enable-posixmutexes

	soversion=`echo ${version} | cut -f1,2 -d.`
	make libdb=%{_libdb_a} libcxx=%{_libcxx_a}
	popd
done


# remove dangling tags symlink from examples.
rm -f examples_cxx/tags
rm -f examples_c/tags

%install
rm -rf ${RPM_BUILD_ROOT}
mkdir -p ${RPM_BUILD_ROOT}%{_bindir}
mkdir -p ${RPM_BUILD_ROOT}%{_libdir}

pushd db.1.85
cd PORT/linux
sover=`echo libdb.so.* | sed 's/libdb.so.//'`
install -m755 libdb.so.$sover           $RPM_BUILD_ROOT/%{_libdir}/libdb1.so.$sover
ln -sf libdb1.so.$sover                 $RPM_BUILD_ROOT/%{_libdir}/libdb.so.$sover
install -s -m755 db_dump185             $RPM_BUILD_ROOT/%{_bindir}/db1_dump185
popd

pushd db2
# Install the shared library.
install -m755 libdb2.so.* $RPM_BUILD_ROOT/%{_libdir}/
# Install the utilities.
for utility in db_archive db_checkpoint db_deadlock db_dump db_load \
db_printlog db_recover db_stat ; do
	install -m755 $utility $RPM_BUILD_ROOT/%{_bindir}/
done
# Rename the utilities.
major=2
for bin in $RPM_BUILD_ROOT/%{_bindir}/*db_* ; do
	t=`echo ${bin} | sed "s,db_,db${major}_,g"`
	mv ${bin} ${t}
done
popd

for version in %{db3_versions} %{db4_versions} ; do
	pushd db-${version}/dist
	%makeinstall libdb=%{_libdb_a} libcxx=%{_libcxx_a}
	# Rename the utilities.
	major=`echo ${version} | cut -c1,3`
	for bin in $RPM_BUILD_ROOT/%{_bindir}/*db_* ; do
		t=`echo ${bin} | sed "s,db_,db${major}_,g"`
		mv ${bin} ${t}
	done
	popd
done

# Make sure all shared libraries have the execute bit set.
chmod 755 $RPM_BUILD_ROOT/%{_libdir}/libdb*.so*

# On Linux systems, move the shared libraries to lib directory.
%ifos linux
if [ "%{_libdir}" != "%{_lib}" ]; then
        mkdir -p $RPM_BUILD_ROOT/%{_lib}
        mv $RPM_BUILD_ROOT/%{_libdir}/libdb2.so.* $RPM_BUILD_ROOT/%{_lib}/
        mv $RPM_BUILD_ROOT/%{_libdir}/libdb-*?.?.so* $RPM_BUILD_ROOT/%{_lib}/
fi
%endif

# Remove unpackaged files.
rm -f $RPM_BUILD_ROOT/%{_includedir}/*
rm -f $RPM_BUILD_ROOT/%{_libdir}/*.la
rm -f $RPM_BUILD_ROOT/%{_libdir}/libdb.so.3
rm -fr $RPM_BUILD_ROOT/%{_libdir}/*.la
rm -fr $RPM_BUILD_ROOT/%{_prefix}/docs/

%clean
rm -rf ${RPM_BUILD_ROOT}

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc docs/*
%ifos linux
/%{_lib}/libdb2.so*
/%{_lib}/libdb-?.?.so
%else
%{_libdir}/libdb2.so*
%{_libdir}/libdb-?.?.so
%endif
%{_libdir}/libdb.so.*
%{_libdir}/libdb1.so.*
%{_bindir}/berkeley_db*_svc
%{_bindir}/db*_archive
%{_bindir}/db*_checkpoint
%{_bindir}/db*_deadlock
%{_bindir}/db*_dump*
%{_bindir}/db*_load
%{_bindir}/db*_printlog
%{_bindir}/db*_recover
%{_bindir}/db*_stat
%{_bindir}/db*_upgrade
%{_bindir}/db*_verify

%changelog
* Tue Nov 30 2004 Jeff Johnson <jbj@redhat.com> 4.1.25-9
- rebuild to fix (possible) s390/s390x stack problems.

* Mon Nov 15 2004 Jeff Johnson <jbj@redhat.com> 4.1.25-8
- rebuild for all arches.

* Sun Nov 14 2004 Jeff Johnson <jbj@jbj.org> 4.1.25-7
- apply sleepycat patch.4.1.25.2 (#136416).
- link libdb-4.1.so against -lpthread (#114150).

* Mon Sep 13 2004 Bill Nottingham <notting@redhat.com>
- return of db1 to compat-db
- remove: db-3.1, db-3.2
- remove: c++, tcl sublibraries

* Tue Mar 02 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Fri Feb 13 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Thu Dec 11 2003 Jeff Johnson <jbj@jbj.org> 4.1.25-1
- retire db-4.1.25 to compat-db.

* Mon Dec 08 2003 Florian La Roche <Florian.LaRoche@redhat.de>
- rebuild for new tcl

* Thu Aug 21 2003 Nalin Dahyabhai <nalin@redhat.com> 4.0.14-6
- rebuild

* Tue Aug 19 2003 Nalin Dahyabhai <nalin@redhat.com> 4.0.14-5
- add missing tcl-devel buildrequires (#101814)

* Thu Jun 26 2003 Jeff Johnson <jbj@redhat.com> 4.0.14-3
- compile on all platforms, use gcc296 only on i386/alpha/ia64
- avoid ppc64 toolchain for the nonce.

* Wed May  7 2003 Bill Nottingham <notting@redhat.com> 4.0.14-2
- build db-4.x with system compiler, not compat-gcc

* Mon May  5 2003 Jeff Johnson <jbj@redhat.com> 4.0.14-1
- add db4.0.14 to the mess.

* Wed Jan 22 2003 Tim Powers <timp@redhat.com>
- rebuilt

* Tue Nov 19 2002 Nalin Dahyabhai <nalin@redhat.com> 3.3.11-3
- add sed as a built-time dependency

* Wed Sep 25 2002 Nalin Dahyabhai <nalin@redhat.com>
- fold x86-64 changes into mainline

* Mon Sep 09 2002 Tim Powers <timp@redhat.com>
- x86-64 specific build

* Sun May 26 2002 Tim Powers <timp@redhat.com> 3.3.11-2
- automated rebuild

* Thu May 16 2002 Nalin Dahyabhai <nalin@redhat.com> 3.3.11-1
- pull in db 3.3, obsolete db3 and db32 in addition to db31
- build with compat-gcc/compat-gcc-c++ to get C++ shared libraries suitable
  for use in applications built with db3-devel on RHL 7.x
- pull in db2, obsolete db2/db2-devel/db3-devel, rename to compat-db
- obsolete db3x

* Thu Mar 28 2002 Nalin Dahyabhai <nalin@redhat.com> 3.2.9-4
- rebuild

* Thu Mar 28 2002 Nalin Dahyabhai <nalin@redhat.com> 3.2.9-3
- don't list the tcl include path before other flags when building libdb_tcl
  3.1.x (tcl is in /usr, so this pulls in /usr/include/db.h, which is wrong)

* Mon Mar 25 2002 Nalin Dahyabhai <nalin@redhat.com> 3.2.9-2
- rebuild

* Mon Mar 25 2002 Nalin Dahyabhai <nalin@redhat.com> 3.2.9-1
- rename to db3x and merge in db 3.1 and db 3.2 compatibility stuffs

* Mon Apr 16 2001 Nalin Dahyabhai <nalin@redhat.com>
- rename to db31, drop the -devel subpackage, merge the -utils package
- remove berkeley_db_svc, libdb_tcl.so (conflicts with current -utils)

* Thu Apr 05 2001 Nalin Dahyabhai <nalin@redhat.com>
- fix URLs in docs for the -utils and -devel subpackages to point to the
  images in the main package's documentation directory (#33328)
- change Copyright: GPL to License: BSDish

* Fri Mar 23 2001 Bill Nottingham <notting@redhat.com>
- turn off --enable-debug

* Tue Dec 12 2000 Jeff Johnson <jbj@redhat.com>
- rebuild to remove 777 directories.

* Sat Nov 11 2000 Jeff Johnson <jbj@redhat.com>
- don't build with --enable-diagnostic.
- add build prereq on tcl.
- default value for %%_lib macro if not found.

* Tue Oct 17 2000 Jeff Johnson <jbj@redhat.com>
- add /usr/lib/libdb-3.1.so symlink to %%files.
- remove dangling tags symlink from examples.

* Mon Oct  9 2000 Jeff Johnson <jbj@redhat.com>
- rather than hack *.la (see below), create /usr/lib/libdb-3.1.so symlink.
- turn off --enable-diagnostic for performance.

* Fri Sep 29 2000 Jeff Johnson <jbj@redhat.com>
- update to 3.1.17.
- disable posix mutexes Yet Again.

* Tue Sep 26 2000 Jeff Johnson <jbj@redhat.com>
- add c++ and posix mutex support.

* Thu Sep 14 2000 Jakub Jelinek <jakub@redhat.com>
- put nss_db into a separate package

* Wed Aug 30 2000 Matt Wilson <msw@redhat.com>
- rebuild to cope with glibc locale binary incompatibility, again

* Wed Aug 23 2000 Jeff Johnson <jbj@redhat.com>
- remove redundant strip of libnss_db* that is nuking symbols.
- change location in /usr/lib/libdb-3.1.la to point to /lib (#16776).

* Thu Aug 17 2000 Jeff Johnson <jbj@redhat.com>
- summaries from specspo.
- all of libdb_tcl* (including symlinks) in db3-utils, should be db3->tcl?

* Wed Aug 16 2000 Jakub Jelinek <jakub@redhat.com>
- temporarily build nss_db in this package, should be moved
  into separate nss_db package soon

* Wed Jul 19 2000 Jakub Jelinek <jakub@redhat.com>
- rebuild to cope with glibc locale binary incompatibility

* Wed Jul 12 2000 Prospector <bugzilla@redhat.com>
- automatic rebuild

* Sun Jun 11 2000 Jeff Johnson <jbj@redhat.com>
- upgrade to 3.1.14.
- create db3-utils sub-package to hide tcl dependency, enable tcl Yet Again.
- FHS packaging.

* Mon Jun  5 2000 Jeff Johnson <jbj@redhat.com>
- disable tcl Yet Again, base packages cannot depend on libtcl.so.

* Sat Jun  3 2000 Jeff Johnson <jbj@redhat.com>
- enable tcl, rebuild against tcltk 8.3.1 (w/o pthreads).

* Tue May 30 2000 Matt Wilson <msw@redhat.com>
- include /lib/libdb.so in the devel package

* Wed May 10 2000 Jeff Johnson <jbj@redhat.com>
- put in "System Environment/Libraries" per msw instructions.

* Tue May  9 2000 Jeff Johnson <jbj@redhat.com>
- install shared library in /lib, not /usr/lib.
- move API docs to db3-devel.

* Mon May  8 2000 Jeff Johnson <jbj@redhat.com>
- don't rename db_* to db3_*.

* Tue May  2 2000 Jeff Johnson <jbj@redhat.com>
- disable --enable-test --enable-debug_rop --enable-debug_wop.
- disable --enable-posixmutexes --enable-tcl as well, to avoid glibc-2.1.3
  problems.

* Mon Apr 24 2000 Jeff Johnson <jbj@redhat.com>
- add 3.0.55.1 alignment patch.
- add --enable-posixmutexes (linux threads has not pthread_*attr_setpshared).
- add --enable-tcl (needed -lpthreads).

* Sat Apr  1 2000 Jeff Johnson <jbj@redhat.com>
- add --enable-debug_{r,w}op for now.
- add variable to set shm perms.

* Sat Mar 25 2000 Jeff Johnson <jbj@redhat.com>
- update to 3.0.55

* Tue Dec 29 1998 Jeff Johnson <jbj@redhat.com>
- Add --enable-cxx to configure.

* Thu Jun 18 1998 Jeff Johnson <jbj@redhat.com>
- Create.
